import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { AboutUsPageCmsService } from "./about-us-page-cms.service";
import { UpdateAboutUsPageCmsDto } from "./dto/update-about-us-page-cms.dto";

@Controller({ path: "about-us-page-cms", version: Constants.API_VERSION_1 })

export class AboutUsPageCmsController {
  constructor(private readonly service: AboutUsPageCmsService) {
  }

  @Post()
  @HttpCode(HttpStatus.OK)
  @UseGuards(AdminAuthGuard)
  updateOrCreateData(
    @Body() dto: UpdateAboutUsPageCmsDto
  ) {
    return this.service.updateOrCreateData(dto);
  }

  @Get()
  // @UseGuards(AdminAuthGuard)
  findAll() {
    return this.service.findAll();
  }
}
