import { EntityRepository, Repository } from "typeorm";
import { UpdateSignupPageCmsDto } from "./dto/update-signup-page-cms.dto";
import { SignupPageCmsEntity } from "./entities/signup-page-cms.entity";

@EntityRepository(SignupPageCmsEntity)
export class SignupPageCmsRepository extends Repository<SignupPageCmsEntity> {

  async createEntity(dto: UpdateSignupPageCmsDto): Promise<SignupPageCmsEntity | Error> {
    try {
      const entity = this.create({
        image: dto.image,
        logo: dto.logo,
        buttonText: dto.buttonText,
        title: dto.title
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateSignupPageCmsDto, id: string): Promise<SignupPageCmsEntity | Error> {
    try {
      await this.update(id, {
        image: dto.image,
        logo: dto.logo,
        buttonText: dto.buttonText,
        title: dto.title
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<SignupPageCmsEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}