import { EntityRepository, Repository } from "typeorm";
import { BlogDetailsPageComponentUiEntity } from "./entities/blog-details-page-component-ui.entity";
import { UpdateBlogDetailsPageComponentUiDto } from "./dto/update-blog-details-page-component-ui.dto";

@EntityRepository(BlogDetailsPageComponentUiEntity)
export class BlogDetailsPageComponentUiRepository extends Repository<BlogDetailsPageComponentUiEntity> {

  async createEntity(dto: UpdateBlogDetailsPageComponentUiDto): Promise<BlogDetailsPageComponentUiEntity | Error> {
    try {
      const entity = this.create({
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateBlogDetailsPageComponentUiDto, id: string): Promise<BlogDetailsPageComponentUiEntity | Error> {
    try {
      await this.update(id, {
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<BlogDetailsPageComponentUiEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}