import { EntityRepository, Repository } from "typeorm";
import { CareerPageComponentUiEntity } from "./entities/career-page-component-ui.entity";
import { UpdateCareerPageComponentUiDto } from "./dto/update-career-page-component-ui.dto";

@EntityRepository(CareerPageComponentUiEntity)
export class CareerPageComponentUiRepository extends Repository<CareerPageComponentUiEntity> {

  async createEntity(dto: UpdateCareerPageComponentUiDto): Promise<CareerPageComponentUiEntity | Error> {
    try {
      const entity = this.create({
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateCareerPageComponentUiDto, id: string): Promise<CareerPageComponentUiEntity | Error> {
    try {
      await this.update(id, {
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<CareerPageComponentUiEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}