import { Module } from "@nestjs/common";
import { TypeOrmModule } from "@nestjs/typeorm";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { FileUploadsService } from "src/modules/file-uploads/file-uploads.service";
import { DoSpacesService } from "src/modules/SpacesModule/SpacesService/doSpacesService";
import { DoSpacesServicerovider } from "src/modules/SpacesModule/SpacesService";
import { LocationPageComponentUiRepository } from "./location-page-component-ui.repository";
import { LocationPageComponentUiController } from "./location-page-component-ui.controller";
import { LocationPageComponentUiService } from "./location-page-component-ui.service";

@Module({
  imports: [
    JwtModule.registerAsync({
      useClass: JwtConfigService
    }),
    TypeOrmModule.forFeature([UsersRepository]),
    TypeOrmModule.forFeature([LocationPageComponentUiRepository])
  ],
  controllers: [LocationPageComponentUiController],
  providers: [LocationPageComponentUiService, JwtHelper, FileUploadsService, DoSpacesService, DoSpacesServicerovider]
})
export class LocationPageComponentUiModule {
}