import { EntityRepository, Repository } from "typeorm";
import { UpdateLocationPageComponentUiDto } from "./dto/update-location-page-component-ui.dto";
import { LocationPageComponentUiEntity } from "./entities/location-page-component-ui.entity";

@EntityRepository(LocationPageComponentUiEntity)
export class LocationPageComponentUiRepository extends Repository<LocationPageComponentUiEntity> {

  async createEntity(dto: UpdateLocationPageComponentUiDto): Promise<LocationPageComponentUiEntity | Error> {
    try {
      const entity = this.create({
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor,
        contactIconColor: dto.contactIconColor,
        locationIconColor: dto.locationIconColor
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateLocationPageComponentUiDto, id: string): Promise<LocationPageComponentUiEntity | Error> {
    try {
      await this.update(id, {
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor,
        contactIconColor: dto.contactIconColor,
        locationIconColor: dto.locationIconColor
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<LocationPageComponentUiEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}