import { EntityRepository, Repository } from "typeorm";
import { TermsAndConditionsPageComponentUiEntity } from "./entities/terms-and-conditions-page-component-ui.entity";
import { UpdateTermsAndConditionsPageComponentUiDto } from "./dto/update-terms-and-conditions-page-component-ui.dto";

@EntityRepository(TermsAndConditionsPageComponentUiEntity)
export class TermsAndConditionsPageComponentUiRepository extends Repository<TermsAndConditionsPageComponentUiEntity> {

  async createEntity(dto: UpdateTermsAndConditionsPageComponentUiDto): Promise<TermsAndConditionsPageComponentUiEntity | Error> {
    try {
      const entity = this.create({
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor
      });
      await this.save(entity);
      return entity;
    } catch (e) {
      return e;
    }
  }

  async updateEntity(dto: UpdateTermsAndConditionsPageComponentUiDto, id: string): Promise<TermsAndConditionsPageComponentUiEntity | Error> {
    try {
      await this.update(id, {
        backgroundColor: dto.backgroundColor,
        pageTitleFontColor: dto.pageTitleFontColor
      });
      return await this.findOne(id);
    } catch (e) {
      return e;
    }
  }

  async findAll(): Promise<TermsAndConditionsPageComponentUiEntity[] | Error> {
    try {
      return await this.find({
        where: {
          isDeleted: false
        }
      });
    } catch (e) {
      return e;
    }
  }
}