import { Module } from "@nestjs/common";
import { CustomerService } from "./customer.service";
import { CustomerController } from "./customer.controller";
import { TypeOrmModule } from "@nestjs/typeorm";
import { RetailerServiceRepository } from "../custom/retailer-service/retailer-service.repository";

@Module({
  imports: [
    TypeOrmModule.forFeature([
      RetailerServiceRepository
    ])
  ],
  controllers: [CustomerController],
  providers: [CustomerService]
})
export class CustomerModule {
}
