import { Injectable } from "@nestjs/common";
import { InjectRepository } from "@nestjs/typeorm";
import { ResponseUtils } from "src/utils/response.utils";
import { CareerRepository } from "../career/career.repository";
import { CareerDepartmentRepository } from "../career-department/career-department.repository";
import { Between, FindOperator, Like } from "typeorm";
import { CareerListPageCmsRepository } from "../CMS/career-list-page-cms/career-list-page-cms.repository";
import { CareerDetailsPageCmsRepository } from "../CMS/career-details-page-cms/career-details-page-cms.repository";
import { WhyJoinUsRepository } from "../why-join-us/why-join-us.repository";
import {
  ScheduleVendorDayBannerCmsRepository
} from "../CMS/schedule-vendor-day-banner-cms/schedule-vendor-day-banner-cms.repository";
import { BlogCategoryRepository } from "../blog/blog-category/blog-category.repository";
import { BlogTagRepository } from "../blog/blog-tag/blog-tag.repository";
import { BlogPostRepository } from "../blog/blog-post/blog-post.repository";
import { UpdateBlogPostDto } from "../blog/blog-post/dto/update-blog-post.dto";
import { BlogPostTagsRepository } from "../blog/blog-post-tags/blog-post-tags.repository";
import { FAQRepository } from "../faq/faq.repository";
import { FaqPageSectionTwoRepository } from "../faq-page-section-two/faq-page-section-two.repository";
import { FAQPageCmsRepository } from "../CMS/faq-page-cms/faq-page-cms.repository";
import { ContactUsPageCmsRepository } from "../CMS/contact-us-page-cms/contact-us-page-cms.repository";
import { ContactUsSectionOneRepository } from "../contact-us-section-one/contact-us-section-one.repository";
import { AboutUsPageCmsRepository } from "../CMS/about-us-page-cms/about-us-page-cms.repository";
import { AboutUsSectionOneCmsRepository } from "../CMS/about-us-section-one-cms/about-us-section-one-cms.repository";
import { AboutUsSectionTwoRepository } from "../about-us-section-two/about-us-section-two.repository";
import { DispoDifferenceSectionRepository } from "../dispo-difference-section/dispo-difference-section.repository";
import { NewsletterBannerCmsRepository } from "../CMS/newsletter-banner-cms/newsletter-banner-cms.repository";
import { ReeferFriendCmsRepository } from "../CMS/reefer-friend-cms/reefer-friend-cms.repository";
import { ReeferFriendRepository } from "../reefer-friend/reefer-friend.repository";
import { HeroSectionLeftCmsRepository } from "../CMS/hero-section-left-cms/hero-section-left-cms.repository";
import { HeroSectionSliderRepository } from "../hero-section-slider/hero-section-slider.repository";
import { HomePageCmsRepository } from "../CMS/home-page-cms/home-page-cms.repository";
import { CareerApplicantRepository } from "../career-applicant/career-applicant.repository";
import { ContactMessageRepository } from "../contact-message/contact-message.repository";
import { RetailerService } from "../dutchie-plus/retailer/retailer.service";
import { RetailerServiceRepository } from "../dutchie-plus/custom/retailer-service/retailer-service.repository";
import { NewsletterRepository } from "../newsletter/newsletter.repository";
import {
  LocationPageComponentUiRepository
} from "../component-ui-cms/location-page-component-ui/location-page-component-ui.repository";
import {
  HomePageComponentUiRepository
} from "../component-ui-cms/home-page-component-ui/home-page-component-ui.repository";
import {
  ShopPageComponentUiRepository
} from "../component-ui-cms/shop-page-component-ui/shop-page-component-ui.repository";
import {
  AboutUsPageComponentUiRepository
} from "../component-ui-cms/about-us-page-component-ui/about-us-page-component-ui.repository";
import {
  CategoriesPageComponentUiRepository
} from "../component-ui-cms/categories-page-component-ui/categories-page-component-ui.repository";
import {
  BrandPageComponentUiRepository
} from "../component-ui-cms/brand-page-component-ui/brand-page-component-ui.repository";
import {
  SpecialPageComponentUiRepository
} from "../component-ui-cms/special-page-component-ui/special-page-component-ui.repository";
import {
  ContactUsPageComponentUiRepository
} from "../component-ui-cms/contact-us-page-component-ui/contact-us-page-component-ui.repository";
import {
  FaqPageComponentUiRepository
} from "../component-ui-cms/faq-page-component-ui/faq-page-component-ui.repository";
import {
  CareerPageComponentUiRepository
} from "../component-ui-cms/career-page-component-ui/career-page-component-ui.repository";
import {
  CareerDepartmentPageComponentUiRepository
} from "../component-ui-cms/career-department-page-component-ui/career-department-page-component-ui.repository";
import {
  CareerDetailsPageComponentUiRepository
} from "../component-ui-cms/career-details-page-component-ui/career-details-page-component-ui.repository";
import {
  BlogPageComponentUiRepository
} from "../component-ui-cms/blog-page-component-ui/blog-page-component-ui.repository";
import {
  PrivacyPolicyPageComponentUiRepository
} from "../component-ui-cms/privacy-policy-page-component-ui/privacy-policy-page-component-ui.repository";
import {
  TermsAndConditionsPageComponentUiRepository
} from "../component-ui-cms/terms-and-conditions-page-component-ui/terms-and-conditions-page-component-ui.repository";
import {
  BlogDetailsPageComponentUiRepository
} from "../component-ui-cms/blog-details-page-component-ui/blog-details-page-component-ui.repository";
import { CommonComponentUiRepository } from "../component-ui-cms/common-component-ui/common-component-ui.repository";

@Injectable()
export class SiteFrontendService {
  constructor(
    @InjectRepository(CareerRepository)
    private readonly careerRepository: CareerRepository,
    @InjectRepository(CareerDepartmentRepository)
    private readonly careerDepartmentRepository: CareerDepartmentRepository,
    @InjectRepository(CareerListPageCmsRepository)
    private readonly careerListPageCmsRepository: CareerListPageCmsRepository,
    @InjectRepository(CareerDetailsPageCmsRepository)
    private readonly careerDetailsPageCmsRepository: CareerDetailsPageCmsRepository,
    @InjectRepository(WhyJoinUsRepository)
    private readonly whyJoinUsRepository: WhyJoinUsRepository,
    @InjectRepository(ScheduleVendorDayBannerCmsRepository)
    private readonly scheduleVendorDayBannerCmsRepository: ScheduleVendorDayBannerCmsRepository,
    @InjectRepository(BlogCategoryRepository)
    private readonly blogCategoryRepository: BlogCategoryRepository,
    @InjectRepository(BlogTagRepository)
    private readonly blogTagRepository: BlogTagRepository,
    @InjectRepository(BlogPostRepository)
    private readonly blogPostRepository: BlogPostRepository,
    @InjectRepository(BlogPostTagsRepository)
    private readonly blogPostTagsRepository: BlogPostTagsRepository,
    @InjectRepository(FAQRepository)
    private readonly faqRepository: FAQRepository,
    @InjectRepository(FaqPageSectionTwoRepository)
    private readonly faqSecTwoRepository: FaqPageSectionTwoRepository,
    @InjectRepository(FAQPageCmsRepository)
    private readonly faqCmsRepository: FAQPageCmsRepository,
    @InjectRepository(ContactUsPageCmsRepository)
    private readonly contactUsPageCmsRepository: ContactUsPageCmsRepository,
    @InjectRepository(ContactUsSectionOneRepository)
    private readonly contactUsSectionOneRepository: ContactUsSectionOneRepository,
    @InjectRepository(AboutUsPageCmsRepository)
    private readonly aboutUsPageCmsRepo: AboutUsPageCmsRepository,
    @InjectRepository(AboutUsSectionOneCmsRepository)
    private readonly aboutUsSectionOneCmsRepo: AboutUsSectionOneCmsRepository,
    @InjectRepository(AboutUsSectionTwoRepository)
    private readonly aboutUsSectionTwoRepo: AboutUsSectionTwoRepository,
    @InjectRepository(DispoDifferenceSectionRepository)
    private readonly dispoDifferenceSectionRepo: DispoDifferenceSectionRepository,
    @InjectRepository(NewsletterBannerCmsRepository)
    private readonly newsletterBannerCmsRepository: NewsletterBannerCmsRepository,
    @InjectRepository(ReeferFriendCmsRepository)
    private readonly reeferFriendCmsRepository: ReeferFriendCmsRepository,
    @InjectRepository(ReeferFriendRepository)
    private readonly reeferFriendRepository: ReeferFriendRepository,
    @InjectRepository(HeroSectionLeftCmsRepository)
    private readonly heroSectionLeftCmsRepository: HeroSectionLeftCmsRepository,
    @InjectRepository(HeroSectionSliderRepository)
    private readonly heroSectionSliderRepository: HeroSectionSliderRepository,
    @InjectRepository(HomePageCmsRepository)
    private readonly homePageCmsRepository: HomePageCmsRepository,
    @InjectRepository(CareerApplicantRepository)
    private readonly careerApplicantRepository: CareerApplicantRepository,
    @InjectRepository(ContactMessageRepository)
    private readonly contactMessageRepository: ContactMessageRepository,
    private readonly retailerService: RetailerService,
    @InjectRepository(RetailerServiceRepository)
    private readonly retailerServiceRepository: RetailerServiceRepository,
    @InjectRepository(NewsletterRepository)
    private readonly newsletterRepository: NewsletterRepository,
    @InjectRepository(LocationPageComponentUiRepository)
    private readonly locationPageComponentUiRepository: LocationPageComponentUiRepository,
    @InjectRepository(HomePageComponentUiRepository)
    private readonly homePageComponentUiRepository: HomePageComponentUiRepository,
    @InjectRepository(ShopPageComponentUiRepository)
    private readonly shopPageComponentUiRepository: ShopPageComponentUiRepository,
    @InjectRepository(AboutUsPageComponentUiRepository)
    private readonly aboutUsPageComponentUiRepository: AboutUsPageComponentUiRepository,
    @InjectRepository(CategoriesPageComponentUiRepository)
    private readonly categoriesPageComponentUiRepository: CategoriesPageComponentUiRepository,
    @InjectRepository(BrandPageComponentUiRepository)
    private readonly brandPageComponentUiRepository: BrandPageComponentUiRepository,
    @InjectRepository(SpecialPageComponentUiRepository)
    private readonly specialPageComponentUiRepository: SpecialPageComponentUiRepository,
    @InjectRepository(ContactUsPageComponentUiRepository)
    private readonly contactUsPageComponentUiRepository: ContactUsPageComponentUiRepository,
    @InjectRepository(FaqPageComponentUiRepository)
    private readonly faqPageComponentUiRepository: FaqPageComponentUiRepository,
    @InjectRepository(CareerPageComponentUiRepository)
    private readonly careerPageComponentUiRepository: CareerPageComponentUiRepository,
    @InjectRepository(CareerDepartmentPageComponentUiRepository)
    private readonly careerDepartmentPageComponentUiRepository: CareerDepartmentPageComponentUiRepository,
    @InjectRepository(CareerDetailsPageComponentUiRepository)
    private readonly careerDetailsPageComponentUiRepository: CareerDetailsPageComponentUiRepository,
    @InjectRepository(BlogPageComponentUiRepository)
    private readonly blogPageComponentUiRepository: BlogPageComponentUiRepository,
    @InjectRepository(PrivacyPolicyPageComponentUiRepository)
    private readonly privacyPolicyPageComponentUiRepository: PrivacyPolicyPageComponentUiRepository,
    @InjectRepository(TermsAndConditionsPageComponentUiRepository)
    private readonly termsAndConditionsPageComponentUiRepository: TermsAndConditionsPageComponentUiRepository,
    @InjectRepository(BlogDetailsPageComponentUiRepository)
    private readonly blogDetailsPageComponentUiRepository: BlogDetailsPageComponentUiRepository,
    @InjectRepository(CommonComponentUiRepository)
    private readonly commonComponentUiRepository: CommonComponentUiRepository
  ) {
  }

  async getCareerPageData(): Promise<any | Error> {
    const careerDepartmentList = await this.careerDepartmentRepository.findByFilterQuery({});
    const totalCount = await this.careerRepository.totalCareerCount();
    let careerDepartmentData: any = [];
    for (let i = 0; i < Object.keys(careerDepartmentList).length; i++) {
      const careerCount = await this.careerRepository.countByDepartmentName(careerDepartmentList[i].name);
      careerDepartmentList[i]["count"] = careerCount;
      careerDepartmentData.push(careerDepartmentList[i]);
    }

    const response = {
      careerDepartmentData: careerDepartmentData,
      totalCount: totalCount
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
  }

  async getCareerDetailsData(id: string): Promise<any | Error> {
    const cmsData = await this.careerDetailsPageCmsRepository.findAll();
    const careerDetailsData = await this.careerRepository.findByFilterQuery({ id: id });
    const whyJoinUsData = await this.whyJoinUsRepository.findByFilterQuery({});
    const latestCareerList = await this.careerRepository.getLatestCareerList();

    const response = {
      cmsData: cmsData,
      careerDetailsData: careerDetailsData,
      whyJoinUsData: whyJoinUsData,
      latestCareerList: latestCareerList
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
  }

  async getCareerDepartmentWiseData(
    departmentNameSlug: any,
    page: number,
    limit: number
  ): Promise<any | Error> {
    type FindOption = {
      departmentName?: FindOperator<string>;
    };

    const findOptions: FindOption = {};

    let departmentData = await this.careerDepartmentRepository.findBySlug(departmentNameSlug);
    let departmentName: any;
    if (Object.keys(departmentData).length > 0) {
      departmentName = departmentData[0].name;
    }

    if (departmentName) findOptions.departmentName = departmentName;

    const cmsData = await this.careerListPageCmsRepository.findAll();
    const whyJoinUsData = await this.whyJoinUsRepository.findByFilterQuery({});
    const careerList = await this.careerRepository.findAllWithPagination(findOptions, page, limit);
    const isCareerDepartmentExist = await this.careerDepartmentRepository.findOne({
      where: {
        name: departmentName,
        isDeleted: false
      }
    });

    let data = {
      cmsData: cmsData,
      careerList: careerList,
      whyJoinUsData: whyJoinUsData,
      isCareerDepartmentExist: typeof isCareerDepartmentExist !== "undefined" ? true : false
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
  }

  async getBlogData(
    page: number,
    limit: number,
    keyword: any,
    tagName: any,
    categoryId: any,
    date?: Date
  ): Promise<any | Error> {
    type FindOption = {
      title?: FindOperator<string>;
      categoryId?: FindOperator<string>;
      createdAt?: FindOperator<Date>;
    };

    let creationDate: any;

    const findOptions: FindOption = {};

    if (keyword) findOptions.title = Like("%" + keyword + "%");
    if (categoryId) findOptions.categoryId = categoryId;
    if (date) creationDate = date;

    const startDate = new Date(creationDate);
    startDate.setUTCHours(0, 0, 0, 0);
    const endDate = new Date(creationDate);
    endDate.setUTCHours(23, 59, 59, 999);

    startDate.toDateString();
    endDate.toDateString();

    if (date) {
      findOptions.createdAt = Between(startDate, endDate);
    }

    if (tagName) {
      const scheduleVendorDayData = await this.scheduleVendorDayBannerCmsRepository.findAll();
      const blogCategoryList = await this.blogCategoryRepository.findByFilterQuery({});
      const blogTagList = await this.blogTagRepository.findByFilterQuery({});
      const topBlogList = await this.blogPostRepository.getTopBlogList();
      const totalBlogCount = await this.blogPostRepository.countAllBlogs();
      const blogList = await this.blogPostRepository.findBlogByTagName(
        page,
        limit,
        tagName
      );

      let data = {
        scheduleVendorDayData: scheduleVendorDayData,
        blogCategoryList: blogCategoryList,
        blogTagList: blogTagList,
        topBlogList: topBlogList,
        blogList: blogList,
        totalBlogCount: totalBlogCount
      };

      return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
    } else {
      const scheduleVendorDayData = await this.scheduleVendorDayBannerCmsRepository.findAll();
      const blogCategoryList = await this.blogCategoryRepository.findByFilterQuery({});
      const blogTagList = await this.blogTagRepository.findByFilterQuery({});
      const topBlogList = await this.blogPostRepository.getTopBlogList();
      const totalBlogCount = await this.blogPostRepository.countAllBlogs();
      const blogList = await this.blogPostRepository.findBlogByFilterQuery(
        page,
        limit,
        findOptions
      );

      let data = {
        scheduleVendorDayData: scheduleVendorDayData,
        blogCategoryList: blogCategoryList,
        blogTagList: blogTagList,
        topBlogList: topBlogList,
        blogList: blogList,
        totalBlogCount: totalBlogCount
      };

      return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
    }
  }

  async getBlogDetailsData(urlSlug: string): Promise<any | Error> {
    const scheduleVendorDayData = await this.scheduleVendorDayBannerCmsRepository.findAll();
    const blogData = await this.blogPostRepository.findOneEntityBySlug(urlSlug);
    let id: any;
    if (Object.keys(blogData).length > 0) {
      id = blogData[0].id;
      let viewCount = 0;
      let totalViews = blogData[0].totalViews;
      let postId = blogData[0].id;
      viewCount = totalViews + 1;
      let blogPostDto = {
        totalViews: viewCount
      };
      await this.blogPostRepository.updateBlogViewCount(
        postId,
        blogPostDto as UpdateBlogPostDto
      );
    }
    const blogTags = await this.blogPostTagsRepository.findBlogPostTagsByPostId(id);
    if (blogTags) {
      blogData[0]["tags"] = blogTags;
    }

    const blogCategoryList = await this.blogCategoryRepository.findByFilterQuery({});
    const blogTagList = await this.blogTagRepository.findByFilterQuery({});
    const topBlogList = await this.blogPostRepository.getTopBlogList();

    let data = {
      scheduleVendorDayData: scheduleVendorDayData,
      blogData: blogData,
      blogCategoryList: blogCategoryList,
      blogTagList: blogTagList,
      topBlogList: topBlogList
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", data);
  }

  async getFaqPageData(): Promise<any | Error> {
    const faqCms = await this.faqCmsRepository.findAll();
    const faqSectionTwo = await this.faqSecTwoRepository.findByFilterQuery({});
    const faq = await this.faqRepository.findByFilterQuery({});

    const response = { faqCms, faqSectionTwo, faq };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
  }

  async getContactUsPageData(): Promise<any | Error> {
    const cmsData = await this.contactUsPageCmsRepository.findAll();
    const sectionOneData = await this.contactUsSectionOneRepository.findByFilterQuery({});

    const response = {
      cmsData: cmsData,
      sectionOneData: sectionOneData
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
  }

  async getAboutUsPageData(): Promise<any | Error> {
    const aboutUsPageCms = await this.aboutUsPageCmsRepo.findAll();
    const aboutUsSectionOneCms = await this.aboutUsSectionOneCmsRepo.findAll();
    const aboutUsSectionTwo = await this.aboutUsSectionTwoRepo.findByFilterQuery({});
    const dispoDifferenceSection = await this.dispoDifferenceSectionRepo.findByFilterQuery({});
    const newsletterBannerCms = await this.newsletterBannerCmsRepository.findAll();

    const response = {
      aboutUsPageCms,
      aboutUsSectionOneCms,
      aboutUsSectionTwo,
      dispoDifferenceSection,
      newsletterBannerCms
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
  }


  async home(): Promise<any | Error> {
    const reeferFriendCms = await this.reeferFriendCmsRepository.findAll();
    const reeferFriend = await this.reeferFriendRepository.findByFilterQuery({});
    const heroSectionLeftCms = await this.heroSectionLeftCmsRepository.findAll();
    const heroSectionSlider = await this.heroSectionSliderRepository.findByFilterQuery({});
    const homePageCms = await this.homePageCmsRepository.findAll();
    const dispoDifference = await this.dispoDifferenceSectionRepo.findByFilterQuery({});
    const newsletterCMS = await this.newsletterBannerCmsRepository.findAll();
    const response = {
      reeferFriendCms,
      reeferFriend,
      heroSectionLeftCms,
      heroSectionSlider,
      homePageCms,
      dispoDifference,
      newsletterCMS
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
  }

  async getDashboardData(): Promise<any | Error> {
    const totalCareerApplicant = await this.careerApplicantRepository.countAllQuery();
    const totalContact = await this.contactMessageRepository.countAllQuery();
    const totalSubscriber = await this.newsletterRepository.countAllQuery();
    const totalArticle = await this.blogPostRepository.countAllBlogs();
    const totalCareer = await this.careerRepository.totalCareerCount();
    const totalRetailer = await this.retailerService.countAllRetailer();
    const topFiveRetailers = await this.retailerServiceRepository.topFiveRetailerEntity();
    let retailerLabel = [];
    let retailerAccessCount = [];
    for (let i = 0; i < Object.keys(topFiveRetailers).length; i++) {
      retailerLabel.push(topFiveRetailers[i].retailerName);
      retailerAccessCount.push(topFiveRetailers[i].accessCount);
    }
    const topFiveRetailerData = {
      labels: retailerLabel,
      data: retailerAccessCount
    };

    const response = {
      totalCareerApplicant: totalCareerApplicant,
      totalCareer: totalCareer,
      totalContact: totalContact,
      totalArticle: totalArticle,
      totalRetailer: totalRetailer,
      topFiveRetailer: topFiveRetailerData,
      totalSubscriber: totalSubscriber
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully", "data", response);
  }

  async getComponentUI(): Promise<any | Error> {
    const locationPageData = await this.locationPageComponentUiRepository.findAll();
    const homePageData = await this.homePageComponentUiRepository.findAll();
    const shopPageData = await this.shopPageComponentUiRepository.findAll();
    const aboutUsPageData = await this.aboutUsPageComponentUiRepository.findAll();
    const categoriesPageData = await this.categoriesPageComponentUiRepository.findAll();
    const brandPageData = await this.brandPageComponentUiRepository.findAll();
    const specialPageData = await this.specialPageComponentUiRepository.findAll();
    const contactUsPageData = await this.contactUsPageComponentUiRepository.findAll();
    const faqPageData = await this.faqPageComponentUiRepository.findAll();
    const careerPageData = await this.careerPageComponentUiRepository.findAll();
    const careerDepartmentPageData = await this.careerDepartmentPageComponentUiRepository.findAll();
    const careerDetailsPageData = await this.careerDetailsPageComponentUiRepository.findAll();
    const blogPageData = await this.blogPageComponentUiRepository.findAll();
    const blogDetailsPageData = await this.blogDetailsPageComponentUiRepository.findAll();
    const privacyPolicyPageData = await this.privacyPolicyPageComponentUiRepository.findAll();
    const termsAndConditionPageData = await this.termsAndConditionsPageComponentUiRepository.findAll();
    const commonPageData = await this.commonComponentUiRepository.findAll();

    const response = {
      locationPage: locationPageData,
      homePage: homePageData,
      shopPage: shopPageData,
      aboutUsPage: aboutUsPageData,
      categoriesPage: categoriesPageData,
      brandPage: brandPageData,
      specialPage: specialPageData,
      contactUsPage: contactUsPageData,
      faqPage: faqPageData,
      careerPage: careerPageData,
      careerDepartmentPage: careerDepartmentPageData,
      careerDetailsPage: careerDetailsPageData,
      blogPage: blogPageData,
      privacyPolicyPage: privacyPolicyPageData,
      termsAndConditionPage: termsAndConditionPageData,
      blogDetailsPage: blogDetailsPageData,
      commonPage: commonPageData
    };

    return ResponseUtils.successResponseHandler(200, "Data fetched successfully!", "data", response);
  }
}
