import { extname } from "path";
import * as sharp from "sharp";
import { v4 as uuidv4 } from "uuid";
import * as fs from "fs";

export class ImageUtils {
  static async resize(
    file: Express.Multer.File,
    width: number,
    height: number
  ): Promise<any> {
    return new Promise((resolve, reject) => {
      const extension = extname(file.originalname);
      const newfilename = `golden_gal.${uuidv4()}_resized${extension}`;
      sharp(file.path)
        .resize(width, height)
        .toFile(`${file.destination}/` + newfilename, function(err, info) {
          if (err) {
            // console.log(err);
            reject(err);
            return;
          }
          console.log(info);
          resolve(newfilename);
        });
    });
  }

  static async defualtSize(file: Express.Multer.File): Promise<string> {
    return new Promise((resolve, reject) => {
      const extension = extname(file.originalname);
      const newfilename = `golden_gal.${uuidv4()}_default${extension}`;
      console.log(file.path);
      fs.renameSync(file.path, `${file.destination}/` + newfilename);
      resolve(newfilename);
    });
  }
}
